package org.jeecg.modules.fbsAbnormalWorkingHours.entity;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 异常工时描述
 * @author： jeecg-boot
 * @date：   2020-10-14
 * @version： V1.0
 */
@Data
@TableName("fbs_abnormal_working_hours_describe")
public class FbsAbnormalWorkingHoursDescribe implements Serializable {
    private static final long serialVersionUID = 1L;
    
	/**异常原因描述主键*/
	@TableId(type = IdType.UUID)
	private String id;
	/**异常工时主键id*/
	@Excel(name = "异常工时主键id", width = 15)
	private String abnormalWorkingHoursId;
	/**描述*/
	@Excel(name = "描述", width = 15)
	private String describes;
	/**备注*/
	@Excel(name = "备注", width = 15)
	private String memo;
	/**删除标记0正常1删除*/
	@Excel(name = "删除标记0正常1删除", width = 15)
	private String delFlag;
	/**创建人*/
	@Excel(name = "创建人", width = 15)
	private String createBy;
	/**创建时间*/
	@Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	private Date createTime;
	/**最后修改人*/
	@Excel(name = "最后修改人", width = 15)
	private String updateBy;
	/**最后修改时间*/
	@Excel(name = "最后修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	private Date updateTime;
	/**自定义字段1*/
	@Excel(name = "自定义字段1", width = 15)
	private String def1;
	/**自定义字段2*/
	@Excel(name = "自定义字段2", width = 15)
	private String def2;
	/**自定义字段3*/
	@Excel(name = "自定义字段3", width = 15)
	private String def3;
	/**自定义字段4*/
	@Excel(name = "自定义字段4", width = 15)
	private String def4;
	/**自定义字段5*/
	@Excel(name = "自定义字段5", width = 15)
	private String def5;
	/**排序*/
	@Excel(name = "排序", width = 15)
	private Integer sort;

	//类型id
	private String typeId;
	//类型名称
	private String typeName;
	/**产品*/
	@Excel(name = "产品", width = 15)
	private String product;/**产品id*/
	@Excel(name = "产品id", width = 15)
	private String productId;
	@Excel(name = "派工单id", width = 15)
	private String workshopDispatchListId;
	@Excel(name = "不良品数量", width = 15)
	private String rejectsNumber;
	@Excel(name = "类别（产品、物料）", width = 15)
	private String type;
	@Excel(name = "计划数量", width = 15)
	private BigDecimal plannedQuantity;

	/**生产订单号*/
	private String productionOrderNumberName;
	/**不良物料名称*/
	private String materielName;
	/**不良物料计划数量*/
	private BigDecimal materielNumberOfTasks;
	/**不良物料不良数量*/
	private BigDecimal materielBadNumber;

	//异常分类总数
	@TableField(exist = false)
	private String total;
	//开始时间
	@TableField(exist = false)
	private String start;
	//结束时间
	@TableField(exist = false)
	private String end;


}
