package org.jeecg.modules.fbsPuArrivalvouch.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.jeecg.modules.fbsPuArrivalvouch.entity.FbsArrivalVouchs;
import org.jeecg.modules.fbsPuArrivalvouch.mapper.FbsArrivalVouchsMapper;
import org.jeecg.modules.fbsPuArrivalvouch.service.IFbsArrivalVouchsService;
import org.jeecg.modules.fbsQualityQualificationRate.entity.FbsQualityQualificationRate;
import org.jeecg.modules.fbsQualityQualificationRate.mapper.FbsQualityQualificationRateMapper;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description: 采购到货退货单主表（表体）
 * @author： jeecg-boot
 * @date：   2020-10-21
 * @version： V1.0
 */
@Service
@DS("multi-datasource1")
public class FbsArrivalVouchsServiceImpl extends ServiceImpl<FbsArrivalVouchsMapper, FbsArrivalVouchs> implements IFbsArrivalVouchsService {
    @Resource
    private FbsArrivalVouchsMapper fbsArrivalVouchsMapper;

    @Resource
    private FbsQualityQualificationRateMapper fbsQualityQualificationRateMapper;

    @Override
    public List<FbsArrivalVouchs> getWillArriveList() {
        return fbsArrivalVouchsMapper.getWillArriveList();
    }

    /**
     * 近6个月质量目标合格率比较
     * @return
     */
    @Override
    public List<Map<String,Object>> getLastSixMonthQualityTargetCompare(){
        return fbsArrivalVouchsMapper.getLastSixMonthQualityTargetCompare();
    }


}
