package org.jeecg.modules.fbsWarehouse.entity;

import java.io.Serializable;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 仓库报表
 * @author： jeecg-boot
 * @date：   2021-01-20
 * @version： V1.0
 */
@Data
@TableName("fbs_warehouse")
public class FbsWarehouse implements Serializable {
    private static final long serialVersionUID = 1L;
    
	/**仓库主键*/
	@TableId(type = IdType.UUID)
	private String id;
	/**日期*/
	@Excel(name = "日期", width = 20, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	private Date date;
	/**应到人数*/
	@Excel(name = "应到人数", width = 15)
	private java.lang.Integer numberOfPeopleToArrive;
	/**实到人数*/
	@Excel(name = "实到人数", width = 15)
	private java.lang.Integer actualNumberOfPeople;
	/**请假*/
	@Excel(name = "请假", width = 15)
	private java.lang.Integer lleave;
	/**旷工*/
	@Excel(name = "旷工", width = 15)
	private java.lang.Integer absenteeism;
	/**离职*/
	@Excel(name = "离职", width = 15)
	private java.lang.Integer quit;
	/**出勤工时*/
	@Excel(name = "出勤工时", width = 15)
	private java.lang.Double attendanceHours;
	/**加班人数*/
	@Excel(name = "加班人数", width = 15)
	private java.lang.Integer overtimePeople;
	/**加班工时*/
	@Excel(name = "加班工时", width = 15)
	private java.lang.Double overtimeHours;
	/**加班原因*/
	@Excel(name = "加班原因", width = 15)
	private java.lang.String overtimeReason;
	/**工单配料*/
	@Excel(name = "工单配料", width = 15)
	private java.lang.Double workOrderBatching;
	/**工单配料-生产订单号*/
	@Excel(name = "工单配料-生产订单号", width = 15)
	private java.lang.String batchingProductionOrderNumberCode;
	/**成品收存*/
	@Excel(name = "成品收存", width = 15)
	private java.lang.Double storageFinishedProducts;
	/**成品收存-生产订单号*/
	@Excel(name = "成品收存-生产订单号", width = 15)
	private java.lang.String productsProductionOrderNumberCode;
	/**原材料收存*/
	@Excel(name = "原材料收存", width = 15)
	private java.lang.Double storageRawMaterials;
	/**入库单号*/
	@Excel(name = "入库单号", width = 15)
	private java.lang.String stockInNumber;
	/**研发领用*/
	@Excel(name = "研发领用", width = 15)
	private java.lang.Double researchAndDevelopment;
	/**研发领用-出库单号*/
	@Excel(name = "研发领用-出库单号", width = 15)
	private java.lang.String developmentDeliveryOrderNo;
	/**项目配料(补发发货)*/
	@Excel(name = "项目配料(补发发货)", width = 15)
	private java.lang.Double projectIngredients;
	/**项目配料-出库单号*/
	@Excel(name = "项目配料-出库单号", width = 15)
	private java.lang.String projectDeliveryOrderNo;
	/**项目发货（售后发货）*/
	@Excel(name = "项目发货（售后发货）", width = 15)
	private java.lang.Double projectDelivery;
	/**项目发货-项目名称*/
	@Excel(name = "项目发货-项目名称", width = 15)
	private java.lang.String deliveryProjectName;
	/**项目打包*/
	@Excel(name = "项目打包", width = 15)
		private java.lang.Double packProject;
	/**项目打包-项目名称*/
	@Excel(name = "项目打包-项目名称", width = 15)
	private java.lang.String packProjectName;
	/**装车*/
	@Excel(name = "装车", width = 15)
	private java.lang.Double loading;
	/**装车-项目名称*/
	@Excel(name = "装车-项目名称", width = 15)
	private java.lang.String loadingProjectName;
	/**盘点*/
	@Excel(name = "盘点", width = 15)
	private java.lang.Double inventory;
	/**物料编号*/
	@Excel(name = "物料编号", width = 15)
	private java.lang.String itemNumber;
	/**培训*/
	@Excel(name = "培训", width = 15)
	private java.lang.Double train;
	/**培训-备注*/
	@Excel(name = "培训-备注", width = 15)
	private java.lang.String trainMemo;
	/**会议*/
	@Excel(name = "会议", width = 15)
	private java.lang.Double meeting;
	/**会议-备注*/
	@Excel(name = "会议-备注", width = 15)
	private java.lang.String meetingMemo;
	/**5S*/
	@Excel(name = "5S", width = 15)
	private java.lang.Double fiveS;
	/**5S-备注*/
	@Excel(name = "5S-备注", width = 15)
	private java.lang.String fiveSMemo;
	/**其他*/
	@Excel(name = "其他", width = 15)
	private java.lang.Double other;
	/**其他-备注*/
	@Excel(name = "其他-备注", width = 15)
	private java.lang.String otherMemo;
	/**备注*/
	@Excel(name = "备注", width = 15)
	private java.lang.String memo;
	/**删除标记0正常1删除*/
	@Excel(name = "删除标记0正常1删除", width = 15)
	private java.lang.String delFlag;
	/**创建人*/
	@Excel(name = "创建人", width = 15)
	private java.lang.String createBy;
	/**创建时间*/
	@Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	private Date createTime;
	/**最后修改人*/
	@Excel(name = "最后修改人", width = 15)
	private String updateBy;
	/**最后修改时间*/
	@Excel(name = "最后修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
	private Date updateTime;
	/**自定义字段1*/
	@Excel(name = "自定义字段1", width = 15)
	private String def1;
	/**自定义字段2*/
	@Excel(name = "自定义字段2", width = 15)
	private String def2;
	/**自定义字段3*/
	@Excel(name = "自定义字段3", width = 15)
	private String def3;
	/**自定义字段4*/
	@Excel(name = "自定义字段4", width = 15)
	private String def4;
	/**自定义字段5*/
	@Excel(name = "自定义字段5", width = 15)
	private String def5;
	/**配辅料*/
	@Excel(name = "配辅料", width = 15)
	private java.lang.Double accessories;
	/**配辅料-出库单号*/
	@Excel(name = "配辅料-出库单号", width = 15)
	private java.lang.String accessoriesDeliveryOrderNo;
	/**支给*/
	@Excel(name = "支给", width = 15)
	private java.lang.Double defray;
	/**支给-备注*/
	@Excel(name = "支给-备注", width = 15)
	private java.lang.String defrayMemo;
	//开始时间
	@TableField(exist = false)
	private String start;
	//结束时间
	@TableField(exist = false)
	private String end;
}
